// Klasa za testiranje

public class Test {

	public static void main(String[] args) {
		
		// kreiramo dva objekta klase Tacka
		Tacka t1 = new Tacka (); // kreira se tacka t1 
		Tacka t2;
		t2 = new Tacka(); //  
		
		System.out.println(t1.x + " " + t1.y); // stampa 0 0
		
		// x i y imaju vrijednost 0 koje im je dodijelio konstruktor bez argumenata
		// podrazumijevani konstruktor uvijek postavlja vrijednosti clanica klase na "nulu" za tip promjenljive
		
		
		// postavljanje vrijednosti clanica klase 
		t2.x = 12.23; 
		t2.y = -1.456;
		
		System.out.println(t2.x + " " + t2.y); // stampa 12.23 -1.456
		
		// Koordinata x tacke t1 je za 1 veca od koordinate y tacke t2
		t1.x = t2.y + 1;
		
		System.out.println(t1); // ako nije definisan metod toString, ovo stampa referencu objekta t1 
		
		// Dodajmo i metod za stampanje tacke - stampa.  
		t1.stampa();
		t2.stampa();
		
		// Napisimo metod koji izracunava rastojanje dvije tacke
		// Prvi metod pisemo u klasi Test - ispod matoda main. Narusavaju se koncepti objektno-orijentisanog programiranja. 
		// Drugi metod pisemo u klasi Tacka.
		
		// Metod iz klase Test
		System.out.println(rastojanje(t1, t3));
		
		// Metod iz klase Tacka - ubuduce cemo uvijek ovako pisati metode
		System.out.println(t1.rastojanje(t2));
		
				
		// Kreirajmo drugu klasu Duz, koja se predstavlja pomocu pocetne i krajnje tacke.
		// Napisati metod duzina koji vraca duzinu duzi.
		
		Duz d1 = new Duz();
		d1.poc = t1; 
		d1.kraj = t2; 
		// Duz d1 dijeli memoriju sa tackama t1 i t2, pa ako promijenimo jednu od tih tacaka, mijenja se i d1.
		
		Duz d2 = new Duz();
		d2.poc = new Tacka();
		d2.kraj = new Tacka(); 
		d2.poc.x = -1; 
		d2.poc.y = 1.5; 
		d2.kraj.x =  53.62;
		d2.kraj.y = -11; 
		
		System.out.println(d1.duzina());
		System.out.println(d2.duzina());
		
		Trougao tr1 = new Trougao(); // poziva se podrazumijevani konstruktor
		
		tr1.tjemeA = t3; 
				
		tr1.tjemeB = new Tacka(); // postavljanje vrijednosti
		System.out.println(tr1.tjemeB); // citanje vrijednosti 
		
	}
	
	public static double rastojanje(Tacka a, Tacka b)
	{
		double d, dx, dy;
		dx = a.getX() - b.getX();
		dy = a.getY() - b.getY ();
		d = Math.sqrt(dx * dx + dy * dy);
		return d;
	}
}
